# number of randomized patients and observed AE for each arm
N1 <- 600; N2 <- 650
X1 <- c(4, 2, 2, 13, 6, 8, 4, 0, 1)
X2 <- c(0, 0, 1, 3, 2, 1, 2, 2, 2)

# calculate original p-value and corresponding attainable p-values using FET
p <- numeric(); p.set <- list()
for (i in 1:9){
  p[i] <- fisher.test(matrix(c(X1[i],N1-X1[i],X2[i],N2-X2[i]),2,2))[[1]]
  s<-c()
  for (j in 0:X[i]){
    s[j+1] <- fisher.test(matrix(c(j,N1-j,X[i]-j,N2-(X[i]-j)),2,2))[[1]]
  }
  p.set[[i]] <- sort(s)
}

# Single-step procedures comparison (Table 1)
SSresult <- cbind(X1, X2, p, 
                  P.MBonf=MBonf.p.adjust(p,p.set),
                  P.Tarone=Tarone.p.adjust(p,p.set), 
                  P.Sidak=Sidak.p.adjust(p),
                  P.Bonf=p.adjust(p,method = "bonferroni"))
SSresult[order(p),]

# Step-down procedures comparison (Table 2)
SDresult <- cbind(X1, X2, p, 
                  P.MHolm=MHolm.p.adjust(p,p.set), 
                  P.TH=TH.p.adjust(p,p.set), 
                  P.Holm=p.adjust(p,method = "holm"))
SDresult[order(p),]

# Step-up procedures comparison (Table 3)
SUresult <- cbind(X1, X2, p, 
                  P.MHoch=MHoch.p.adjust(p,p.set), 
                  P.Roth=Roth.p.adjust(p,p.set), 
                  P.Hoch=p.adjust(p,method = "hochberg"))
SUresult[order(p),]